package observations;

import java.util.*;
import java.lang.*;

public class CompositeObservationType extends ObservationType implements ObservationFactory
{ 
  Vector components;
  
  public CompositeObservationType(Vector observationTypes, String aName)
  { validator = (Validator)new DefaultValidator();
    components = new Vector(observationTypes);
    name = aName;
  }


  public Observation createObservation()
  { return new CompositeObservation(this, instantiateComponents()); } 

  private Vector instantiateComponents()
  {
    Vector instances = new Vector(components.size());
    Enumeration enum = components.elements();
    while( enum.hasMoreElements())	
    { instances.addElement(((ObservationFactory)enum.nextElement()).createObservation()); }
    return instances;
  }

  public boolean isValid(CompositeObservation observation)
  {/*iterate over collection of observations and validate them*/
    Enumeration enum = observation.components.elements();
    boolean flag = true;
    while(flag & enum.hasMoreElements())	
    { flag = flag & ((Observation)enum.nextElement()).isValid(); }
    return flag;
  } 
} 
